/* 
   [sd.c]
   (c) Simon Kueppers
   20.12.06 Germany

   This file is the interface to the sdcard. For this case, it emulates a ram drive with a given size.
   (DISK_SIZE). 
   

   PS:
   I tried to comment the code as best as i was able to. This is a little bit confusing
   for a german, so please excuse if something is not that right it should be.
   Have fun with this code but remember the BEER LICENSE when you copy+paste something
   from here :-)

*/

#include <stdio.h>									//fopen() fclose() fread()
#include <windows.h>
#include "stdint.h"									//Vartypedefs
#include "sd.h"										//function prototypes for sd card access


HANDLE hDevice;               // handle to the drive to be examined

/*
   Inits SD-Card interface.
   Should be run once at startup
*/
void sd_init(void)
{

   hDevice = CreateFile("\\\\.\\K:", 
                    GENERIC_READ |
					GENERIC_WRITE,
                    //FILE_SHARE_READ | // share mode
                    //FILE_SHARE_WRITE,
					0,
                    NULL,             // default security attributes
                    OPEN_EXISTING,    // disposition
                    0,                // file attributes
                    NULL);            // do not copy file attributes

}

/*
   Writes 512 bytes of data to disk at pageadress
*/
void sd_write(uint32_t adress, void *p_src)
{
	uint32_t nByteswritten;
	
	SetFilePointer(hDevice, adress, NULL, FILE_BEGIN);
	WriteFile(hDevice, p_src, 512, &nByteswritten, NULL);
	
}

/*
   Reads 512 bytes of data from disk at pageadress
*/
void sd_read (uint32_t adress, void *p_dst)
{
	uint32_t nBytesread;
	
	SetFilePointer(hDevice, adress, NULL, FILE_BEGIN);
	ReadFile(hDevice, p_dst, 512, &nBytesread, NULL);

}

/*
   Reads nBytes bytes of data from disk at pageadress
*/
void sd_nread (uint32_t adress, void *p_dst, uint16_t nBytes)
{
	uint32_t nBytesread;
	uint8_t buffer[512];

	SetFilePointer(hDevice, adress, NULL, FILE_BEGIN);
	ReadFile(hDevice, buffer, 512, &nBytesread, NULL);

	memcpy(p_dst, buffer, nBytes);


}

/*
   Writes nBytes bytes of data to disk at pageadress and pads enough zeros to write 512byte
*/
void sd_nwrite (uint32_t adress, void *p_src, uint16_t nBytes)
{
	uint32_t nByteswritten;
	uint8_t buffer[512];

	memcpy(buffer, p_src, nBytes);

	SetFilePointer(hDevice, adress, NULL, FILE_BEGIN);
	WriteFile(hDevice, buffer, 512, &nByteswritten, NULL);
	


}