/* 
   uFS Project [ufs_diskio.c]
   (c) Simon Kueppers
   20.12.06 Germany

   This file is made to get some info about the disk, that is used by uFS
  
   PS:
   I tried to comment the code as best as i was able to. This is a little bit confusing
   for a german, so please excuse if something is not that right it should be.
   Have fun with this code but remember the BEER LICENSE when you copy+paste something
   from here :-)

*/

#include <string.h>									//strcpy()
#include "ufs_core.h"								//function prototypes to ufs-core
#include "sd.h"										//function prototypes to access sd card
#include "stdint.h"									//Vartypedefs
#include "ufs.h"									//function prototypes and defines


/*
   This function returns the free space, that is available on disk
*/
uint32_t ufs_getfreespace()
{
	struct t_page TempPage;
	uint32_t temp;
	uint32_t space = 0;

	sd_nread(DISKHEADER_ADR, &TempPage, 4);			//Fetch disk header to get to start of free-space-chain

	while ((temp = TempPage.hdr_pNextpage) != 0)	//while there is a next page in this free-space-chain
	{
		sd_nread(temp, &TempPage, 6);				//Fetch the first 6 byte to buffer (includes pNextpage(4bytes) and nValidbytes(2bytes))
		space += 512;								//And calculate each page as 512 byte of free space
	}

	return space;									//return free space
}

/*
   This function returns the size of the disk
*/
uint32_t ufs_getdisksize()
{
	struct t_page TempPage;

	sd_read(DISKHEADER_ADR, &TempPage);

	return TempPage.diskheadpage.disksize;
}
/*
   This function returns the space on disk, that is used 
*/
uint32_t ufs_getusedspace()
{
	return ufs_getdisksize() - ufs_getfreespace();
}

/*
   This function gets the disk name
*/
uint8_t* ufs_getdiskname(uint8_t* diskname)
{
	struct t_page TempPage;

	sd_read(DISKHEADER_ADR, &TempPage);

	strcpy(diskname, TempPage.diskheadpage.diskname);

	return diskname;
}