
#include <stdio.h>
#include "ufs.h"
#include "stdint.h"
#include <string.h>

#define filename "img.img"
#define sizeofdisk 0x7640000UL


void erasebuffer(void* buffer, uint32_t size)
{
	while(size)
	{
		*((uint8_t*) buffer) = 0;
		((uint8_t*) buffer)++;
		size--;
	}
}

int main()
{

	FILE* fp;
	struct t_page buffer;
	uint32_t i;
	
	fp = fopen(filename, "w+b");

	erasebuffer(&buffer, 512);

	//gets(buffer.diskheadpage.diskname);
	strcpy(buffer.diskheadpage.diskname, "General purpose disk name");
	buffer.diskheadpage.disksize = sizeofdisk;
	buffer.hdr_nValidbytes = 504;
	buffer.hdr_pNextpage = 1024;

	fwrite(&buffer, 1, 512, fp);

	erasebuffer(&buffer, 512);

	buffer.headpage.attrflags = ATTR_ISDIR;
	buffer.headpage.filesize = 0;
	strcpy(buffer.headpage.objname, "root");
	buffer.headpage.pParent = 0;

	fwrite(&buffer, 1, 512, fp);

	erasebuffer(&buffer, 512);

	for (i=1024; i < sizeofdisk; i += 512)
	{
		if ((i+512) < sizeofdisk)
			buffer.hdr_pNextpage = i + 512;
		else
			buffer.hdr_pNextpage = 0;

		fwrite(&buffer, 1, 512, fp);
	}


	fclose(fp);

	return 0;

}